
package eaa.sorting.intern;

import eaa.sorting.Comparable;

public class Element implements Comparable {

    private static int comparisions = 0;
    private int key = 0;

    protected Element(int key) {
        this.key = key;
    }

    public boolean isLess(Comparable e) {
        comparisions = getComparisions() + 1;
        return key < ((Element)e).key;
    }

    public boolean isGreater(Comparable e) {
        comparisions = getComparisions() + 1;
        return key > ((Element) e).key;
    }

    public boolean isEqual(Comparable e) {
        comparisions = getComparisions() + 1;
        return key == ((Element) e).key;
    }

    public boolean isLessOrEqual(Comparable e) {
        comparisions = getComparisions() + 1;
        return key <= ((Element) e).key;
    }

    public boolean isGreaterOrEqual(Comparable e) {
        comparisions = getComparisions() + 1;
        return key >= ((Element) e).key;
    }

    public String toString() {
        return String.valueOf(key);
    }

    public static String stats() {
        return "Comparisions: "+getComparisions();
    }

    public static int getComparisions() {
        return comparisions;
    }

    public static int getCost() {
        return comparisions;
    }

    protected static void resetCounter() {
        comparisions = 0;
    }

}










